#! /usr/bin/python
# ex: set expandtab shiftwidth=4 softtabstop=4:

import sys
import os
import shutil
import re
import time
import string
import urllib

curl = '/usr/bin/curl'
curl_success = '#RESULT: OK\n'
inprocess = '-20'
completed = '-5'
unviewed = '0'
viewed   = '20'
read = '50'
dictated = '60'
preliminary = '80'
final = '100'

debug = 'TRUE'

# Notes -
# styiuid : qe_SYUI
# timestamp format: (tm_year,tm_mon,tm_day,tm_hour,tm_min,tm_sec,tm_wday,tm_yday,tm_isdst)

# Needs access.cfg
#[root@trshub2 ~]# cat /home/medsrv/var/iface/access.cfg 
#127.0.0.1="ASBQDEFORTPHX"
#192.168.25.172="ASBQDEFORTPHX"

# End notes



def querydb(sql_cmd, mysql_bin="/home/medsrv/component/mysql/bin/mysql", mysql_db="imagemedical"):

    """ Queries mysql database. The sql_cmd could be built roughly like this:
        sql_cmd = '"select ID, HOST, AE, TYPE, HOSTNAME, PORT, APPLICID, FACILITYID,\
                    RECVTO, SENDTO, PROTOCOL  from Target where type = \'%s\';"' % devicetype
    """
   
    cmd = "/bin/echo %s | %s -N %s" % (sql_cmd, mysql_bin, mysql_db)
    lQueryrows = os.popen(cmd).readlines()

    if lQueryrows: # Don't bother stripping linefeeds if the result set is empty
        lQueryrows = stripLinefeeds(lQueryrows)

    return lQueryrows 
# End of querydb()

def stripLinefeeds(lines):
    rv = []
    for line in lines:
        if line[-1] == '\n':
            line = line[:-1]
        rv.append(line)
    return rv
# stripLinefeeds()




def doStatusModify(styiuid, newstatus):
    curlargs = "https://127.0.0.1/iface/editStudy.jsp?cStudy=%s\&cMode=Soft\&qe_STAT=%s 2>/dev/null" \
        % (styiuid, newstatus)
    print curlargs
    cmd = "%s %s" % (curl, curlargs)
    r = os.popen(cmd).readlines()
    print "%s" % r
    if curl_success in r:
        res = 'TRUE'
    else:
        res = 'FALSE'

    return res
# doStatusModify


def doModify(styiuid, qeflags):

    curlargs = "https://127.0.0.1/iface/editStudy.jsp?cStudy=%s\&cMode=Soft\&%s 2>/dev/null" \
        % (styiuid, qeflags)
    cmd = "%s %s" % (curl, curlargs)
    r = os.popen(cmd).readlines()
    print "%s" % r
    if curl_success in r:
        res = 'TRUE'
    else:
        res = 'FALSE'

    return res
# end of doModify()


def usage():                                                                                                                                   
    print                                                                                                                                      
    print "./setMigrateStudyStatus.py <styiuid> <status>"                                                                                                          
    print                                                                                                                                      
    print "ex:"                                                                                                                                
    print "./setMigrateStudyStatus.py 1.2.840.3.4.5 20"                                                                                                                       
    print "Would set styiuid 1.2.840.3.4.5 to viewed"
# end of usage()
 
# Main

# Get styiuid from commandline
# loop until styiuid is in db
#     Query database for styiuid
#     See if it is unviewed
#     if it is, mark it viewed and return success
#     if it is not, return success


# Read commandline arguments

try:
    styiuid = sys.argv[1]
    status =  sys.argv[2]

except IndexError:
    usage()
    sys.exit()

# Some database queries for use later
queryunviewed = '"select STYIUID from Dcstudy where MAINST = \'%s\';"' % unviewed
querystudystatus = '"select MAINST from Dcstudy where STYIUID = \'%s\';"' % styiuid


sql_cmd = querystudystatus
study_status = -250
counter = 0
exitstatus = 1

while study_status == -250 and counter < 6:
    counter += 1
    try:
        study_status = querydb(querystudystatus)[0]
        #print "%s : %s" % (styiuid, study_status)
        #print "%s < 20 : %s" % (study_status, int(study_status) < 20)

        if int(study_status) < status:
            # Set the study to specified status 
            print "Setting %s to %s" % (styiuid, status)
            res = doStatusModify(styiuid, status)
            #print "%s" % res

            if res == 'FALSE':
                print "Error setting %s to %s" % (styiuid, status)
                #print "Exiting with status 1"
                #print "Skipping"
                exitstatus = 1
                break

            else:
                print "Successfully set %s to %s" % (styiuid, status)
                #time.sleep(5)
                #study_status = querydb(querystudystatus)[0]
                study_status = status
                exitstatus = 0
                break

        else:
            print "Study is already viewed, nothing to do"
            exitstatus=0
            break

    except IndexError:
        print "%s does not appear to be registered yet, sleeping 10" % styiuid
        time.sleep(10)


#study_status = querydb(querystudystatus)[0]
if int(study_status) != int(status):
    exitstatus = 1

print "%s : %s" % (styiuid, study_status)
sys.exit(exitstatus)


