#! /bin/bash
id=$1

. /home/medsrv/etc/setenv.sh

MYSQL=$MYSQL_HOME/bin/mysql
DB=imagemedical

function listDotcomServers() {
    # returns all dotcom devices connected to this device
    res=$(echo "select ID from Target where type = 'P' or type = 'C';" | \
        $MYSQL -N $DB)
    echo $res
} # End of listDotcomServers()

function connectToDotcomDevice() {
    # Connects (ssh) to the specified device id
    local id=$1
    local ip=$(echo "select HOST from Target where ID = '$id';" | \
        $MYSQL -N $DB)
    ssh $ip
}
 
if [ -z "$id" ]; then
    echo
    echo "usage: $0 <id>"
    echo
    echo "Where id is one of the following:"
    listDotcomServers
    echo
    exit 1
fi

connectToDotcomDevice $id

