#! /bin/bash

# Find styiuids where studies were deleted that had SR objects
# AFTER the first time "keep reports" was turned on.

. ~/var/conf/serverid.cfg

# Find the oldest log where we were supposed to have kept reports
# This cuts down on false positives (although there's nothing saying that "keep reports"
# wasn't subsequently turned off and then back on.

echo "Finding earliest 'keep reports' activity" >&2
oldest=$(for l in $(ls -1tr ~/var/logs.dated/forever/*info*); do \
    if zgrep "non-report" $l > /dev//null ; then \
         echo "$l"; \
         break; \
    fi; \
    done)

echo "First keep reports logged is in $oldest" >&2
ls -al $oldest >&2

echo  "$oldest" > ~/tmp/logstocheck
find /home/medsrv/var/logs.dated/forever/ -newer $oldest -name "*info*"|sort >> ~/tmp/logstocheck

echo "Inspecting logs for deleted studies without 'non-report' entries ($(wc -l ~/tmp/logstocheck))" >&2

> ~/tmp/del.studies # Clear the del.studies list
cat ~/tmp/logstocheck | while read l; do
    #echo "Finding deleted studies without 'non-report' entries in $l"
    zgrep "STUDY delete @system" $l | grep -v "non-report" | awk '{print $11}' >> ~/tmp/del.studies
done
numtocheck=$(wc -l ~/tmp/del.studies|awk '{print $1}')
echo "Operating on ~/tmp/del.studies ($numtocheck)" >&2

count=0
> ${SELF_SERVER_ID}.deletedwithSR.ls
for s in $(cat ~/tmp/del.studies); do
    (( count += 1 ))
    echo "Checking if an SR ever existed in $s ($count/$numtocheck)" >&2
    for l in $(ls -1tr ~/var/logs.dated/forever/*info*); do
        if zgrep "\<$s\>" $l | grep -e SR > /dev/null ; then
            echo "$s : had SR and was fully deleted" >&2
            echo "$s" >> ${SELF_SERVER_ID}.deletedwithSR.ls
            break # Skip to next study in list
        fi
    done
done

