#! /bin/bash

. scripttools.new.shi

sleeptime=3
errorcount=0
successcount=0

targethostid=$1

if [ -z "$targethostid" ]; then
    echo "$0 <targethostid>"
    exit 1
fi

isinTargetTable=$(sql.sh "select ID from Target where ID = '$targethostid';" -N)

if [ -z "$isinTargetTable" ]; then
    echo "Error: $targethostid is not a device id listed in the target table"
    exit 1
fi

# For testing
#for styiuid in $(sql.sh "select styiuid from Dcstudy limit 1 ;" -N); do
for styiuid in $(sql.sh "select styiuid from Dcstudy order by rcvdate desc;" -N); do

    [ -e forwardStudies.cfg ] && . forwardStudies.cfg

    if grep $styiuid migrated.styiuids > /dev/null ; then
        echo "$styiuid already in migrated.styiuids, skipping" >&2
        (( successcount+=1 ))
        continue
    fi

    if grep $styiuid errored.styiuids > /dev/null ; then
        echo "$styiuid in errored.styiuids, skipping" >&2
        (( errorcount+=1 ))
        continue
    fi

    niceme >&2 && break

    echo "Generating tasks for $styiuid" >&2
    ~/component/taskd/runjavacmd -c "0 cases.Forward -s $styiuid -H $targethostid -u migration"
    retval=$?
    if [ $retval -ne 0 ]; then
        echo "$styiuid : error $retval"
        (( errorcount+=1 ))
        echo "$styiuid" >> errored.styiuids
        #exit $retval
    else
        echo $styiuid >> migrated.styiuids
        (( successcount+=1 ))
    fi

    echo "Successcount: $successcount | Errorcount: $errorcount (includes previous runs)" >&2
    if [ $sleeptime -gt 0 ]; then
        echo "Sleeping $sleeptime to let the queue stabilize" >&2
        sleep $sleeptime
    fi
done

echo "Successcount: $successcount | Errorcount: $errorcount (includes previous runs)" >&2

