#! /bin/bash

. etc/setenv.sh

[ -z "$1" ] && echo "$0 <styiuid>" && exit 1
styiuid=$1

function getRepo() {
    styiuid=$1
    loc=$(${REPOSITORY_HANDLER_HOME}/scripts/locateStudy.sh -d ${styiuid})
    [ $? -ne 0 ] && return 1
    echo $loc
    return 0
}

tags="(f215,1045) (f215,1046)"
loc=$(getRepo $styiuid)

[ -z "$loc" ] && echo "ERROR: No such study $styiuid" && exit

pbr=$(find $loc -name "PbR*")
echo "$pbr"

for t in $tags; do
    echo "Removing $t"
    echo "$HOME/component/dcviewer/dcmod -d -t \"$t\" $pbr"
    $HOME/component/dcviewer/dcmod -d -t "$t" $pbr
done

echo "Clearing obsinfo.rec"
rm ${loc}/.info/obsinfo.rec

echo "Reindexing $styiuid"
$HOME/component/cases/reindexStudy.sh -e $styiuid



