#! /bin/bash

createPrefetch_() {

local destdir="$1"

    if [ ! -d "$destdir"/filters/ ]; then
         echo "No filters directory. Not doing anything"
         return 1
    fi

    echo "Creating empty prefetch list:"
    cat > "$destdir"/filters/prefetch.rec << EndofData
# THIS IS A GENERATED FILE. DO NOT EDIT !!!

cFields="DATE
PANM
STAT
MODY
DSCR
PHRF
PHRD
NIMG"
cStat="true"
cSorts="a_DATE"
qf_DATE="()(!0123456)()"
EndofData

} # createPrefetch_()

unset changedusers

OIFS=$IFS
IFS="
"

for userdir in $(find ~/data/users -type d -maxdepth 1 -mindepth 1); do 
    echo "User : $userdir"
    echo -n "        Checking for prefetch worklist: "
    result=$(find $userdir -name prefetch.rec)

    if [ -n "$result" ]; then
        echo "Found"
    else
        echo "Not Found"
        createPrefetch_ "$userdir"
        [ $? -eq 0 ] && changedusers=$(echo $changedusers $(basename $userdir))
    fi
done

IFS=$OIFS

echo "Changed the following users: $changedusers"

