#!/bin/sh
# criley 
# This script can be used to extraxt the payload from an rpm.
# In case, for example, someone accidentally removed the rpm rpm.
# usage:  sh $0 <package.rpm> | cpio -d -i 
# If you are replacing rpm itself, the packages you need are
# rpm, rpm-libs, and rpm-python

# This script will extract the payload in the current directory
# Some permissions will be wrong!

# To put all the files in place, do:
# tar -cf - <space separated list of extracted directories> | (cd /; tar -xvf - )
# If you re replacing rpm, do rpm -ivh on rpm, rpm-libs, and rpm-python

# then, to fix the permissions, do:
# for p in $(rpm -qa); do rpm --setperms $p; done

# For RHEL5, uncomment the "xz -d" line at the end of this script
# and cvomment out the "gzip" line

function usage_ () {
    echo "usage:  sh $0 <package.rpm> | cpio -d -i "
    echo "More is needed, see the script for further instructions"
    exit 1
}

[ -z "$1" ] && usage_

pkg=$1
if [ "$pkg" = "" -o ! -e "$pkg" ]; then
   echo "no package supplied" 1>&2
   exit 1
fi

leadsize=96
o=$(expr $leadsize + 8)
set $(od -j $o -N 8 -t u1 $pkg)
il=$(expr 256 \* \( 256 \* \( 256 \* $2 + $3 \) + $4 \) + $5)
dl=$(expr 256 \* \( 256 \* \( 256 \* $6 + $7 \) + $8 \) + $9)
sigsize=$(expr 8 + 16 \* $il + $dl)
o=$(expr $o + $sigsize + \( 8 - \( $sigsize \% 8 \) \) \% 8 + 8)
set $(od -j $o -N 8 -t u1 $pkg)
il=$(expr 256 \* \( 256 \* \( 256 \* $2 + $3 \) + $4 \) + $5)
dl=$(expr 256 \* \( 256 \* \( 256 \* $6 + $7 \) + $8 \) + $9)
hdrsize=$(expr 8 + 16 \* $il + $dl)
o=$(expr $o + $hdrsize)

#dd if=$pkg ibs=$o skip=1 2>/dev/null | xz -d
dd if=$pkg ibs=$o skip=1 2>/dev/null | gzip -d

