#!/bin/bash

. ./funcs.shi

[ -z "$1" ] && echo "Usage: $0 STYIUID" && exit 1

echo -e "\n\n----------------------------------------------------"
echo -e "\tCurrent Study: $1"
PARENT=`getParent`
echo -e "\tMy Parent is: $PARENT"

HASH=`$HOME/component/utils/bin/getHashDirectory -i $1`
echo "HASH is $HASH"
isOnParent $1 $PARENT
ONPARENT="$?"
echo "isOnParent returned $ONPARENT"

function pushToParent()
{
  
   if [ -e $HOME/data/dicom.hashed/${HASH} ] ; then
      echo "HashDir exists"
      ssh -n $PARENT mkdir -p $HOME/data/dicom/$1
      RES=$?
      echo "mkdir on $PARENT returned $RES"
      rsync -va -e ssh $HOME/data/dicom.hashed/${HASH}* $PARENT:$HOME/data/dicom/$1
      RES=$?
      echo "rsync returned $RES"
      ssh -n $PARENT $HOME/component/cases/reindexStudy.sh -r $1
      RES=$?
      echo "reindex on $PARENT returned $RES"
      exit
   
   elif [ -e $HOME/data/dicom/$1 ] ; then
      echo "Legacy Dir exists"
      ssh -n $PARENT mkdir -p $HOME/data/dicom/$1
      RES=$?
      echo "mkdir on $PARENT returned $RES"
      rsync -va -e ssh $HOME/data/dicom/$1/ $PARENT:$HOME/data/dicom/$1
      RES=$?
      echo "rsync returned $RES"
      ssh -n $PARENT $HOME/component/cases/reindexStudy.sh -r $1
      RES=$?
      echo "reindex on $PARENT returned $RES"
      exit
   else
      echo "Study not present on this server"
      exit 100
   fi

}

#########################################################################
#
#  Hazard Scenario
#
#########################################################################
#if [ -e $HOME/data/dicom.hashed/${HASH} ] ; then
#   echo "HashDir exists"
#   ssh -n $PARENT mkdir -p $HOME/data/dicom/$1
#   RES=$?
#   echo "mkdir on $PARENT returned $RES"
#   rsync -va -e ssh $HOME/data/dicom.hashed/${HASH}* $PARENT:$HOME/data/dicom/$1
#   RES=$?
#   echo "rsync returned $RES"
#   ssh -n $PARENT $HOME/component/cases/reindexStudy.sh -r $1
#   RES=$?
#   echo "reindex on $PARENT returned $RES"
#   exit
#
#elif [ -e $HOME/data/dicom/$1 ] ; then
#   echo "Legacy Dir exists"
#   ssh -n $PARENT mkdir -p $HOME/data/dicom/$1
#   RES=$?
#   echo "mkdir on $PARENT returned $RES"
#   rsync -va -e ssh $HOME/data/dicom/$1/ $PARENT:$HOME/data/dicom/$1
#   RES=$?
#   echo "rsync returned $RES"
#   ssh -n $PARENT $HOME/component/cases/reindexStudy.sh -r $1
#   RES=$?
#   echo "reindex on $PARENT returned $RES"
#   exit
#else
#   echo "Study not present on this server"
#   exit 100
#fi
#
#
#########################################################################
#
#  MCAI scenario (push to parent for possibly the first time)
#
#########################################################################
#if [ $ONPARENT -eq 2 ] ; then
#  echo "on Parent but deleted.  Clearing references on parent"
#  ssh -n $PARENT /home/medsrv/checkrefs.sh -s $1 -R -S -c
#elif [ $ONPARENT -eq 1 ] ; then
#  echo "Not On parent"
#  $HOME/component/utils/bin/storestate -S $1 --fwddevice="$PARENT"
#elif [ $ONPARENT -eq 0 ] ; then
#  echo "on Parent and NOT deleted.  Reindexing study on parent"
#  ssh -n $PARENT /home/medsrv/component/cases/reindexStudy.sh -r $1
#  exit 0
#fi
#. $HOME/data/dicom/$1/.info/storestate.rec
#
#if [ "$PROCESSMODE" = "deleted" ] ; then
#  
#else
#  $HOME/component/cases/reindexStudy.sh -r $1
#fi

#########################################################################
#
#  Richardson scenario (cleanup of old children)
#
#########################################################################
#ARCHDIR=`ssh -n $PARENT $HOME/component/tools/q_archiveloc.sh $1`
#echo -e "\tArchive Directory: $ARCHDIR"
#NEWARCHDIR=`echo $ARCHDIR | sed -e's!/home/medsrv/var/archive/!!'`
#if [ -z "$NEWARCHDIR" ] ; then
#   echo "No real archive directory is set, exiting."
#   exit 120
#fi
#
#ssh -n $PARENT mkdir -p $ARCHDIR
#RES=$?
#echo -e "\tmkdir on parent returned: $RES"
#rsync -va -e ssh $HOME/data/dicom/$1/* $PARENT:$ARCHDIR/
