#!/bin/bash

# Be sure that SSH keys are set up between servers!


numtokeep=15
userbackupdir=/home/medsrv/userbackup
remoteserver=247radbk

[ ! -d "$userbackupdir" ] && mkdir $userbackupdir

for backup in $(ls -t $userbackupdir/userbackup.*.tar); do
    (( count += 1 ))
    if [ $count -gt $numtokeep ]; then
        rm -f $backup
        echo "Removing old backup: $backup"
    fi
done

if ~/component/tools/exportusers.sh -f $userbackupdir/userbackup.$(date +%F).tar ; then
    echo "backup succeed"
else
    echo "backup failed"
    exit 200
fi

if rsync -a --delete -e ssh $userbackupdir/ root@"$remoteserver":$userbackupdir ; then
    echo "rsync succeed"
else
    echo "rsync failed"
    exit 201
fi

exit 0

